Index: /DCWoRMS/trunk/build/classes/test/ariel/FCFSCPUFreqScalingPlugin.java
===================================================================
--- /DCWoRMS/trunk/build/classes/test/ariel/FCFSCPUFreqScalingPlugin.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/test/ariel/FCFSCPUFreqScalingPlugin.java	(revision 539)
@@ -0,0 +1,109 @@
+package test.ariel;
+
+import gridsim.dcworms.DCWormsTags;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.events.scheduling.TaskFinishedEvent;
+import schedframe.events.scheduling.TaskRequestedTimeExpiredEvent;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.computing.ComputingNode;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.units.Memory;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.UsedResourcesList;
+import schedframe.scheduling.manager.resources.ClusterResourceManager;
+import schedframe.scheduling.manager.resources.ResourceManager;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plan.impl.SchedulingPlan;
+import schedframe.scheduling.plugin.grid.ModuleList;
+import schedframe.scheduling.queue.TaskQueue;
+import schedframe.scheduling.queue.TaskQueueList;
+import schedframe.scheduling.tasks.TaskInterface;
+import schedframe.scheduling.tasks.WorkloadUnit;
+import dcworms.schedframe.scheduling.Executable;
+import example.localplugin.BaseLocalSchedulingPlugin;
+
+public class FCFSCPUFreqScalingPlugin extends BaseLocalSchedulingPlugin {
+
+	int cnt;
+
+	public SchedulingPlanInterface<?> schedule(SchedulingEvent event, TaskQueueList queues, JobRegistry jobRegistry,
+			 ResourceManager resManager, ModuleList modules) {
+		
+		ClusterResourceManager resourceManager = (ClusterResourceManager) resManager;
+		SchedulingPlan plan = new SchedulingPlan();
+		// chose the events types to serve.
+		// Different actions for different events are possible.
+		switch (event.getType()) {
+		case START_TASK_EXECUTION:
+			
+		//case TIMER:
+			// our tasks are placed only in first queue (see
+			// BaseLocalPlugin.placeJobsInQueues() method)
+			TaskQueue q = queues.get(0);
+			
+			// check all tasks in queue
+			for (int i = 0; i < q.size(); i++) {
+				WorkloadUnit job = q.get(i);
+				TaskInterface<?> task = (TaskInterface<?>) job;
+				// if status of the tasks in READY
+				if (task.getStatus() == DCWormsTags.READY) {
+
+					Map<ResourceUnitName, ResourceUnit> choosenResources = chooseResourcesForExecution(resourceManager, task);
+					if (choosenResources != null) {
+						addToSchedulingPlan(plan, task, choosenResources);
+					}
+					
+					for(Processor cpu: resourceManager.getProcessors()){
+						cpu.getPowerInterface().setPState("P"+cnt);
+					}
+				}
+			}
+			break;
+		}
+		cnt++;
+		return plan;
+	}
+
+	private Map<ResourceUnitName, ResourceUnit> chooseResourcesForExecution(
+			ClusterResourceManager resourceManager, TaskInterface<?> task) {
+
+		Map<ResourceUnitName, ResourceUnit> map = new HashMap<ResourceUnitName, ResourceUnit>();
+		List<Processor> processors = resourceManager.getProcessors();
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 1;
+		}
+
+		if (cpuRequest != 0) {
+
+			List<Processor> choosenProcessor = new ArrayList<Processor>();				
+			for (int i = 0; i < processors.size() && cpuRequest > 0; i++) {
+				if (processors.get(i).getStatus() == ResourceStatus.FREE) {
+					choosenProcessor.add(processors.get(i));
+					cpuRequest--;
+				}
+			}
+
+			ProcessingElements result = new ProcessingElements();
+			result.addAll(choosenProcessor);
+			map.put(StandardResourceUnitName.PE, result);
+		}
+	
+		return map;
+	}
+
+
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/units/ResourceUnit.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/units/ResourceUnit.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/units/ResourceUnit.java	(revision 539)
@@ -23,4 +23,6 @@
 	public void init(Parameters parameters);
 	
+	public Parameters getParameters();
+	
 	public ResourceUnitProvisioner getProvisioner();
 }
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/units/AbstractResourceUnit.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/units/AbstractResourceUnit.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/units/AbstractResourceUnit.java	(revision 539)
@@ -78,5 +78,8 @@
 	public ResourceUnitProvisioner getProvisioner() {
         return provisioner;
-
+	}
+	
+	public Parameters getParameters(){
+		return null;
 	}
 
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/DataCenter.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/DataCenter.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/DataCenter.java	(revision 539)
@@ -3,5 +3,5 @@
 import schedframe.resources.computing.description.ComputingResourceDescription;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerProfileFactory;
+import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 
@@ -11,5 +11,5 @@
 		super(resDesc);
 		//extensionList.add(new EnergyExtension(this, resDesc.getPowerInterface(), resDesc.getEnergyEstimationPlugin()));
-		PowerInterface pi = PowerProfileFactory.createPowerInterface(this, resDesc.getPowerProfile());
+		PowerInterface pi = PowerInterfaceFactory.createPowerInterface(this, resDesc.getPowerProfile());
 		accept(new EnergyExtension(pi, resDesc.getPowerProfile()));
 	}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ComputingNode.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ComputingNode.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ComputingNode.java	(revision 539)
@@ -10,5 +10,5 @@
 import schedframe.resources.computing.extensions.ExtensionType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerProfileFactory;
+import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.ui.ComputingNodePowerInterface;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
@@ -26,5 +26,5 @@
 		
 		//extensionList.add(new EnergyExtension(this, resDesc.getPowerInterface(), resDesc.getEnergyEstimationPlugin()));
-		PowerInterface pi = PowerProfileFactory.createPowerInterface(this, resDesc.getPowerProfile());
+		PowerInterface pi = PowerInterfaceFactory.createPowerInterface(this, resDesc.getPowerProfile());
 		accept(new EnergyExtension(pi, resDesc.getPowerProfile()));	
 	}
@@ -39,10 +39,10 @@
 	
 	public ComputingNodePowerInterface getPowerInterface(){
-		ComputingNodePowerInterface powerProfile = null;
+		ComputingNodePowerInterface powerInterface = null;
 		if(extensionList.isExtensionAvailable(ExtensionType.ENERGY_EXTENSION)){
 			EnergyExtension ee = (EnergyExtension)extensionList.getExtension(ExtensionType.ENERGY_EXTENSION);
-			powerProfile = (ComputingNodePowerInterface)ee.getPowerInterface();
+			powerInterface = (ComputingNodePowerInterface)ee.getPowerInterface();
 		}
-		return powerProfile;
+		return powerInterface;
 	}
 
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ComputingResource.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ComputingResource.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ComputingResource.java	(revision 539)
@@ -2,5 +2,5 @@
 
 import gridsim.GridSimTags;
-import gridsim.gssim.WormsTags;
+import gridsim.dcworms.DCWormsTags;
 
 import java.util.ArrayList;
@@ -28,4 +28,5 @@
 import schedframe.resources.computing.profiles.energy.EnergyEventType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.computing.properties.DefaultPropertiesBuilder;
@@ -68,5 +69,5 @@
 	}
 
-	//TODO remove if possible (check if all scenarios can be realized - statistics issue) , since it's temporary method
+	//TODO remove if possible (check if all scenarios can be realized - statistics issue), since it's a temporary method
 	private void addFakeProcessors() {
 		if(getResourceCharacteristic().getResourceUnits().get(StandardResourceUnitName.PE) != null){
@@ -145,5 +146,4 @@
 		sec.execute(event);
 
-		
 		//old, correctly working method
 		/*if (extensionList != null) {
@@ -157,5 +157,5 @@
 		//if(scheduler != null && (parent != null && scheduler != parent.getScheduler())/*scheduler.getResources().contains(this)*/){
 		//	String src = event.getSource() != null ? event.getSource() : name;
-		//	scheduler.sendInternal(GridSimTags.SCHEDULE_NOW, GssimTags.UPDATE, src);
+		//	scheduler.sendInternal(GridSimTags.SCHEDULE_NOW, DCWormsTags.UPDATE, src);
 		//}
 		//triggerEventUp(event);
@@ -188,5 +188,5 @@
 	}
 	
-	protected List<? extends ComputingResource> searchDescendants(List<ResourceValidator> validators, boolean cutoff) {
+	protected List<? extends ComputingResource> searchDescendants(List<ResourceValidator> validators, boolean cutOff) {
 
 		List<ComputingResource> descendants = new ArrayList<ComputingResource>();
@@ -198,6 +198,4 @@
 				ComputingResource resource = toExamine.pop();
 				List<ComputingResource> resources = resource.getChildren();
-				/*if (resources == null)
-					continue;*/
 				int numberOfRes = resources.size();
 				for (int i = 0; i < numberOfRes; i++) {
@@ -205,5 +203,5 @@
 					if (resourceChild.match(validators)) {
 						descendants.add(resourceChild);
-						if(cutoff == false) {
+						if(cutOff == false) {
 							toExamine.addLast(resourceChild);
 						}
@@ -243,4 +241,16 @@
 		return null;
 	}
+	
+	public AirThroughputInterface getAirThroughputInterface(){
+		if (extensionList != null) {
+			for (Extension extension : extensionList) {
+				if (extension.getType() == ExtensionType.ENERGY_EXTENSION) {
+					EnergyExtension ee = (EnergyExtension)extension;
+					return ee.getAirThroughputInterface();
+				}
+			}
+		}
+		return null;
+	}
 
 	public Scheduler getScheduler() {
@@ -257,5 +267,5 @@
 	}
 
-	class SimpleEventHandler implements EventHandler{
+	class ComputingResourceEventHandler implements EventHandler{
 		
 		public void handleResourceEvent(Event event){
@@ -275,5 +285,5 @@
 			if(scheduler != null && (parent != null && scheduler != parent.getScheduler())/*scheduler.getResources().contains(this)*/){
 				String src = event.getSource() != null ? event.getSource() : name;
-				scheduler.sendInternal(GridSimTags.SCHEDULE_NOW, WormsTags.UPDATE, src);
+				scheduler.sendInternal(GridSimTags.SCHEDULE_NOW, DCWormsTags.UPDATE, src);
 			} else if(parent != null)
 				parent.getEventHandler().handleSchedulingEvent(event);
@@ -282,13 +292,21 @@
 	
 	public EventHandler getEventHandler(){
-		return new SimpleEventHandler();
+		return new ComputingResourceEventHandler();
 	}
 	
 	public void initiate(){
+		
 		ResourceEventCommand rec = new ResourceEventCommand(this);
-		EnergyEvent event = new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, "Resource controller");
+		EnergyEvent event = new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, "Resource controller");
 		event.setReason(EventReason.SIM_INIT);
 		rec.execute(event);
+		
+		rec = new ResourceEventCommand(this);
+		event = new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, "Resource controller");
+		event.setReason(EventReason.SIM_INIT);
+		rec.execute(event);
+		
 		//alternative way
+		//getEventHandler().handleResourceEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, "Resource controller"));
 		//getEventHandler().handleResourceEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, "Resource controller"));
 	}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Processor.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Processor.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Processor.java	(revision 539)
@@ -8,5 +8,5 @@
 import schedframe.resources.computing.extensions.ExtensionType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerProfileFactory;
+import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.computing.profiles.energy.power.ui.ProcessorPowerInterface;
@@ -22,5 +22,5 @@
 		super(resDesc);
 		//extensionList.add(new EnergyExtension(this, resDesc.getPowerInterface(), resDesc.getEnergyEstimationPlugin()));
-		PowerInterface pi = PowerProfileFactory.createPowerInterface(this, resDesc.getPowerProfile());
+		PowerInterface pi = PowerInterfaceFactory.createPowerInterface(this, resDesc.getPowerProfile());
 		accept(new EnergyExtension(pi, resDesc.getPowerProfile()));	
 	}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ResourceFactory.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ResourceFactory.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/ResourceFactory.java	(revision 539)
@@ -11,5 +11,5 @@
 import schedframe.scheduling.policy.local.LocalManagementSystem;
 import schedframe.scheduling.queue.TaskQueueList;
-import simulator.WormsConstants;
+import simulator.DCWormsConstants;
 
 
@@ -20,4 +20,6 @@
 		if (resDesc.getType().equals(StandardResourceType.DataCenter))
 			return new DataCenter(resDesc);
+		else if (resDesc.getType().equals(StandardResourceType.Rack))
+			return  new Rack(resDesc);
 		else if (resDesc.getType().equals(StandardResourceType.ComputingNode))
 			return  new ComputingNode(resDesc);
@@ -46,5 +48,5 @@
 			}
 			case LS: {
-				ms = new LocalManagementSystem(id, WormsConstants.MANAGEMENT_SYSTEM,
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
 						schedulingPlugin, execTimeEstimationPlugin, queues);
 				return new Scheduler(ms, type, managedResources);
@@ -52,5 +54,5 @@
 
 		default:{
-				ms = new LocalManagementSystem(id, WormsConstants.MANAGEMENT_SYSTEM,
+				ms = new LocalManagementSystem(id, DCWormsConstants.MANAGEMENT_SYSTEM,
 						schedulingPlugin, execTimeEstimationPlugin, queues);
 				return new Scheduler(ms, type, managedResources);
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Rack.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Rack.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Rack.java	(revision 539)
@@ -6,5 +6,5 @@
 import schedframe.resources.computing.description.ComputingResourceDescription;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerProfileFactory;
+import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 
@@ -14,5 +14,5 @@
 	public Rack (ComputingResourceDescription resDesc) {
 		super(resDesc);
-		PowerInterface pi = PowerProfileFactory.createPowerInterface(this, resDesc.getPowerProfile());
+		PowerInterface pi = PowerInterfaceFactory.createPowerInterface(this, resDesc.getPowerProfile());
 		accept(new EnergyExtension(pi, resDesc.getPowerProfile()));	
 	}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Core.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Core.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/Core.java	(revision 539)
@@ -3,5 +3,5 @@
 import schedframe.resources.computing.description.ComputingResourceDescription;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.power.PowerProfileFactory;
+import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.units.CpuSpeed;
@@ -13,5 +13,5 @@
 	public Core (ComputingResourceDescription resDesc) {
 		super(resDesc);
-		PowerInterface pi = PowerProfileFactory.createPowerInterface(this, resDesc.getPowerProfile());
+		PowerInterface pi = PowerInterfaceFactory.createPowerInterface(this, resDesc.getPowerProfile());
 		accept(new EnergyExtension(pi, resDesc.getPowerProfile()));	
 	}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerProfile.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerProfile.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerProfile.java	(revision 539)
@@ -19,14 +19,16 @@
 	protected Map<String, PState> supportedPStates;
 	
+	protected Parameters parameters;
+	
 
-	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<schedframe.resources.computing.profiles.energy.power.PowerState> supportedPowerStates) {
+	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<PowerState> powerStates) {
 		this.energyEstimationPlugin = energyEstimationPlugin;
 		this.powerUsage = new ArrayList<PowerUsage>();
-		this.supportedPowerStates = supportedPowerStates;
+		this.supportedPowerStates = powerStates;
 	}
 	
-	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<schedframe.resources.computing.profiles.energy.power.PowerState> supportedPowerStates,  List<schedframe.resources.computing.profiles.energy.power.PState> pStates) {
+	public PowerProfile(EnergyEstimationPlugin energyEstimationPlugin, List<PowerState> powerStates,  List<PState> pStates) {
 		this.energyEstimationPlugin = energyEstimationPlugin;
-		this.supportedPowerStates = supportedPowerStates;
+		this.supportedPowerStates = powerStates;
 		this.powerUsage = new ArrayList<PowerUsage>();
 		if(pStates.size() > 0)
@@ -98,7 +100,12 @@
 	}
 
-	public void init(Parameters parameters){
-		
+	public void init(Parameters params){
+		this.parameters = params;
+	}
+	
+	public Parameters getParameters() {
+		return parameters;
 	}
 
+
 }
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 539)
@@ -10,5 +10,5 @@
 	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
 
-	public double estimateEnergyDissipation(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
+	public double estimateAirThroughput(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
 
 	public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, ComputingResource resource);
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerUsage.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerUsage.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerUsage.java	(revision 539)
@@ -1,24 +1,10 @@
 package schedframe.resources.computing.profiles.energy.power;
 
-public class PowerUsage {
+import schedframe.resources.computing.profiles.energy.MeasurementHistory;
 
-	protected long timestamp;
-	protected double value;
+public class PowerUsage extends MeasurementHistory{
 
 	public PowerUsage(long timestamp, double value){
-		this.timestamp = timestamp;
-		this.value = value;
-	}
-	
-	public long getTimestamp() {
-		return timestamp;
-	}
-
-	public double getValue() {
-		return value;
-	}
-	
-	public void setValue(double value) {
-		this.value = value;
+		super(timestamp, value);
 	}
 	
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ComputingNodePowerInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ComputingNodePowerInterface.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ComputingNodePowerInterface.java	(revision 539)
@@ -10,5 +10,5 @@
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
 
-public class ComputingNodePowerInterface extends AbstractPowerInterface{
+public class ComputingNodePowerInterface extends ComputingResourcePowerInterface{
 
 	public static long START_TIME = 600000;
@@ -28,13 +28,18 @@
 		currentPowerState = state;
 		ComputingNode computingNode = (ComputingNode) resource;
+		boolean pePowerStateChangeStatus = false;
 		if(computingNode.getProcessors() != null)
 		{
 			for(ComputingResource child:computingNode.getProcessors()){
-				child.getPowerInterface().setPowerState(state);
+				if(child.getPowerInterface() != null){
+					pePowerStateChangeStatus = child.getPowerInterface().setPowerState(state);	
+				}
 			}
-		} else {
+		} 
+		
+		if(!pePowerStateChangeStatus){
 			computingNode.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, computingNode.getName()));
 		}
-		
+
 		if(state == StandardPowerStateName.OFF){
 			computingNode.setStatus(ResourceStatus.UNAVAILABLE);
@@ -46,31 +51,4 @@
 		return true;
 	}
-	
-	/*public double getPowerConsumption(PowerState state) {
-		if(currentPowerState == PowerState.OFF)
-			return 0;
-		else if(currentPowerState == PowerState.ON)
-			return 750;
-		else return 500;
-	}*/
-
-	/*public boolean supportPowerState(PowerState state) {
-		switch(state){
-			case ON: 
-				return true;
-			case OFF: 
-				return true;
-			case SLEEP: 
-				return true;
-			case HIBERNATE: 
-				return true;
-			default: 
-				return false;
-		}
-	}
-
-	public List<PowerState> getSupportedPowerStates() {
-		return Arrays.asList(new PowerState[]{PowerState.ON, PowerState.OFF, PowerState.SLEEP, PowerState.HIBERNATE});
-	}*/
 
 	public void turnOn(){
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 539)
@@ -0,0 +1,123 @@
+package schedframe.resources.computing.profiles.energy.power.ui;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.joda.time.DateTimeUtils;
+
+import schedframe.Parameters;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.power.PowerProfile;
+import schedframe.resources.computing.profiles.energy.power.PowerState;
+import schedframe.resources.computing.profiles.energy.power.PowerStateName;
+import schedframe.resources.computing.profiles.energy.power.PowerUsage;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+
+public class ComputingResourcePowerInterface implements PowerInterface{
+
+	protected PowerStateName currentPowerState;
+	protected PowerProfile powerProfile;
+	protected ComputingResource resource;
+	
+	public ComputingResourcePowerInterface(ComputingResource resource, PowerProfile powerProfile){
+		this.resource = resource;
+		this.powerProfile = powerProfile;
+		this.currentPowerState = StandardPowerStateName.ON;
+	}
+	
+	public boolean setPowerState(PowerStateName state) {
+		if(supportPowerState(state)){
+			currentPowerState = state;
+
+			for(ComputingResource child:resource.getChildren()){
+				if(child.getPowerInterface().supportPowerState(state)){
+					boolean status = child.getPowerInterface().setPowerState(state);
+					if(status == false) {
+						resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource));
+					}
+				}
+			}
+
+			if(state == StandardPowerStateName.OFF){
+				resource.setStatus(ResourceStatus.UNAVAILABLE);
+			}
+			else if(state == StandardPowerStateName.ON){
+				resource.setStatus(ResourceStatus.FREE);
+			}
+			//notifications from all levels
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getName()));
+
+			//notification from last level
+			//if (resource.getChildren() == null) resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource));
+			
+			return true;
+		}
+		return false;
+	}
+	
+
+	public PowerStateName getPowerState() {
+		return currentPowerState;
+	}
+
+	public List<PowerState> getSupportedPowerStates() throws NoSuchFieldException {
+		List<PowerState> powerStates = new ArrayList<PowerState>();
+		for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+			powerStates.add(powerState);
+		}
+		return powerStates;
+	}
+
+	public boolean supportPowerState(PowerStateName state) {
+		try {
+			for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+				if(powerState.getName().equals(state)){
+					return true;
+				}
+			}
+		} catch (NoSuchFieldException e) {
+			return false;
+		}
+		return false;
+		
+	}
+	
+	public double getPowerConsumption(PowerStateName state) throws NoSuchFieldException {
+		double powerConsumption = 0;
+		if(supportPowerState(state)){
+			for(PowerState powerState: powerProfile.getSupportedPowerStates()){
+				if(powerState.getName().equals(state)){
+					powerConsumption = powerState.getPowerUsage();
+					break;
+				}
+			}
+		}
+		return powerConsumption;
+	}
+
+	public PowerUsage getRecentPowerUsage() {
+		PowerUsage powerUsage = null;
+		int lastIdx = getPowerUsageHistory().size() - 1;
+		if(lastIdx >= 0)
+			powerUsage = getPowerUsageHistory().get(lastIdx);
+		else {	
+			try {
+				powerUsage = new PowerUsage(DateTimeUtils.currentTimeMillis(), getPowerConsumption(currentPowerState));
+			} catch (NoSuchFieldException e) {
+			}
+		}
+		return powerUsage;
+	}
+	
+	public List<PowerUsage> getPowerUsageHistory(){
+		return powerProfile.getPowerUsageHistory();
+	}
+	
+	public Parameters getParameters() {
+		return powerProfile.getParameters();
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/PowerInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/PowerInterface.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/PowerInterface.java	(revision 539)
@@ -3,4 +3,5 @@
 import java.util.List;
 
+import schedframe.Parameters;
 import schedframe.resources.computing.profiles.energy.power.PowerState;
 import schedframe.resources.computing.profiles.energy.power.PowerStateName;
@@ -25,3 +26,4 @@
 	List<PowerUsage> getPowerUsageHistory();
 	
+	public Parameters getParameters();
 }
